List of libraries that can be used in forensic software. This is mostly just an extension of the
overview of [github.com/libyal/libyal](https://github.com/libyal/libyal/wiki/Overview), which is an
insane collection of parsers. View a little wider: http://cugu.github.io/awesome-forensics/LIBS

| URL                                                                   | Description (Language)                                                         |                                                                                      Last Commit |                                                                                       Stars |                                                                                  License |
|-----------------------------------------------------------------------|--------------------------------------------------------------------------------|-------------------------------------------------------------------------------------------------:|--------------------------------------------------------------------------------------------:|-----------------------------------------------------------------------------------------:|
| **Forensic Artifact Handling**                                        |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [artifactlib](https://github.com/forensicanalysis/artifactlib)        | Process forensic artifact definition files (Go &amp; Python)                   |    ![Last Commit](https://img.shields.io/github/last-commit/forensicanalysis/artifactlib?label=) |    ![GitHub stars](https://img.shields.io/github/stars/forensicanalysis/artifactlib?label=) |    ![License](https://img.shields.io/github/license/forensicanalysis/artifactlib?label=) |
| [artifacts](https://github.com/ForensicArtifacts/artifacts)           | Process forensic artifact definition files (Python)                            |     ![Last Commit](https://img.shields.io/github/last-commit/ForensicArtifacts/artifacts?label=) |     ![GitHub stars](https://img.shields.io/github/stars/ForensicArtifacts/artifacts?label=) |     ![License](https://img.shields.io/github/license/ForensicArtifacts/artifacts?label=) |
| **High Level File System Parser**                                     |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [fslib](https://github.com/forensicanalysis/fslib)                    | Parse filesystems, archives and other data types (Go)                          |          ![Last Commit](https://img.shields.io/github/last-commit/forensicanalysis/fslib?label=) |          ![GitHub stars](https://img.shields.io/github/stars/forensicanalysis/fslib?label=) |          ![License](https://img.shields.io/github/license/forensicanalysis/fslib?label=) |
| [dfvfs](https://github.com/log2timeline/dfvfs)                        | Digital Forensics Virtual File System (Python)                                 |              ![Last Commit](https://img.shields.io/github/last-commit/log2timeline/dfvfs?label=) |              ![GitHub stars](https://img.shields.io/github/stars/log2timeline/dfvfs?label=) |              ![License](https://img.shields.io/github/license/log2timeline/dfvfs?label=) |
| [pytsk](https://github.com/py4n6/pytsk)                               | Bindings for The Sleuth Kit (libtsk) (Python)                                  |                     ![Last Commit](https://img.shields.io/github/last-commit/py4n6/pytsk?label=) |                     ![GitHub stars](https://img.shields.io/github/stars/py4n6/pytsk?label=) |                     ![License](https://img.shields.io/github/license/py4n6/pytsk?label=) |
| **Store**                                                             |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [forensicstore](https://github.com/forensicanalysis/forensicstore)    | A forensics storage format (Go &amp; Python)                                   |  ![last-commit](https://img.shields.io/github/last-commit/forensicanalysis/forensicstore?label=) |  ![GitHub stars](https://img.shields.io/github/stars/forensicanalysis/forensicstore?label=) |  ![License](https://img.shields.io/github/license/forensicanalysis/forensicstore?label=) |
| [acstore](https://github.com/log2timeline/acstore)                    | Attribute Container store (Python)                                             |            ![last-commit](https://img.shields.io/github/last-commit/log2timeline/acstore?label=) |            ![GitHub stars](https://img.shields.io/github/stars/log2timeline/acstore?label=) |            ![License](https://img.shields.io/github/license/log2timeline/acstore?label=) |
| **Cross-platform Functionality**                                      |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [libcdata](https://github.com/libyal/libcdata/wiki/)                  | generic data functions (C)                                                     |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcdata?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libcdata?label=) |                 ![License](https://img.shields.io/github/license/libyal/libcdata?label=) |
| [libcdatetime](https://github.com/libyal/libcdatetime/wiki/)          | date and time functions (C)                                                    |             ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcdatetime?label=) |             ![GitHub stars](https://img.shields.io/github/stars/libyal/libcdatetime?label=) |             ![License](https://img.shields.io/github/license/libyal/libcdatetime?label=) |
| [libcdirectory](https://github.com/libyal/libcdirectory/wiki/)        | directory functions (C)                                                        |            ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcdirectory?label=) |            ![GitHub stars](https://img.shields.io/github/stars/libyal/libcdirectory?label=) |            ![License](https://img.shields.io/github/license/libyal/libcdirectory?label=) |
| [libcerror](https://github.com/libyal/libcerror/wiki/)                | error functions (C)                                                            |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcerror?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libcerror?label=) |                ![License](https://img.shields.io/github/license/libyal/libcerror?label=) |
| [libcfile](https://github.com/libyal/libcfile/wiki/)                  | file functions (C)                                                             |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcfile?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libcfile?label=) |                 ![License](https://img.shields.io/github/license/libyal/libcfile?label=) |
| [libclocale](https://github.com/libyal/libclocale/wiki/)              | locale functions (C)                                                           |               ![Last Commit](https://img.shields.io/github/last-commit/libyal/libclocale?label=) |               ![GitHub stars](https://img.shields.io/github/stars/libyal/libclocale?label=) |               ![License](https://img.shields.io/github/license/libyal/libclocale?label=) |
| [libcnotify](https://github.com/libyal/libcnotify/wiki/)              | notification functions (C)                                                     |               ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcnotify?label=) |               ![GitHub stars](https://img.shields.io/github/stars/libyal/libcnotify?label=) |               ![License](https://img.shields.io/github/license/libyal/libcnotify?label=) |
| [libcpath](https://github.com/libyal/libcpath/wiki/)                  | path functions (C)                                                             |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcpath?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libcpath?label=) |                 ![License](https://img.shields.io/github/license/libyal/libcpath?label=) |
| [libcsplit](https://github.com/libyal/libcsplit/wiki/)                | split string functions (C)                                                     |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcsplit?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libcsplit?label=) |                ![License](https://img.shields.io/github/license/libyal/libcsplit?label=) |
| [libcthreads](https://github.com/libyal/libcthreads/wiki/)            | threads functions (C)                                                          |              ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcthreads?label=) |              ![GitHub stars](https://img.shields.io/github/stars/libyal/libcthreads?label=) |              ![License](https://img.shields.io/github/license/libyal/libcthreads?label=) |
| [dfdatetime](https://github.com/log2timeline/dfdatetime)              | Digital Forensics date and time (Python)                                       |         ![Last Commit](https://img.shields.io/github/last-commit/log2timeline/dfdatetime?label=) |         ![GitHub stars](https://img.shields.io/github/stars/log2timeline/dfdatetime?label=) |         ![License](https://img.shields.io/github/license/log2timeline/dfdatetime?label=) |
| **Data Formats**                                                      |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [libcaes](https://github.com/libyal/libcaes/wiki/)                    | AES encryption functions (C)                                                   |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcaes?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libcaes?label=) |                  ![License](https://img.shields.io/github/license/libyal/libcaes?label=) |
| [libfcache](https://github.com/libyal/libfcache/wiki/)                | generic file data cache functions (C)                                          |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfcache?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libfcache?label=) |                ![License](https://img.shields.io/github/license/libyal/libfcache?label=) |
| [libfcrypto](https://github.com/libyal/libfcrypto/wiki/)              | encryption formats (C)                                                         |               ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfcrypto?label=) |               ![GitHub stars](https://img.shields.io/github/stars/libyal/libfcrypto?label=) |               ![License](https://img.shields.io/github/license/libyal/libfcrypto?label=) |
| [libfdata](https://github.com/libyal/libfdata/wiki/)                  | generic file data functions (C)                                                |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfdata?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libfdata?label=) |                 ![License](https://img.shields.io/github/license/libyal/libfdata?label=) |
| [libfdatetime](https://github.com/libyal/libfdatetime/wiki/)          | for date and time formats (C)                                                  |             ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfdatetime?label=) |             ![GitHub stars](https://img.shields.io/github/stars/libyal/libfdatetime?label=) |             ![License](https://img.shields.io/github/license/libyal/libfdatetime?label=) |
| [libfguid](https://github.com/libyal/libfguid/wiki/)                  | for GUID/UUID format (C)                                                       |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfguid?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libfguid?label=) |                 ![License](https://img.shields.io/github/license/libyal/libfguid?label=) |
| [libfmapi](https://github.com/libyal/libfmapi/wiki/)                  | for Message API (MAPI) data types (C)                                          |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfmapi?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libfmapi?label=) |                 ![License](https://img.shields.io/github/license/libyal/libfmapi?label=) |
| [libfole](https://github.com/libyal/libfole/wiki/)                    | for Object Linking and Embedding (OLE) data types (C)                          |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfole?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libfole?label=) |                  ![License](https://img.shields.io/github/license/libyal/libfole?label=) |
| [libfplist](https://github.com/libyal/libfplist/wiki/)                | for plist formats (C)                                                          |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfplist?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libfplist?label=) |                ![License](https://img.shields.io/github/license/libyal/libfplist?label=) |
| [libftxf](https://github.com/libyal/libftxf/wiki/)                    | for Transactional NTFS (TxF) data types (C)                                    |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libftxf?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libftxf?label=) |                  ![License](https://img.shields.io/github/license/libyal/libftxf?label=) |
| [libftxr](https://github.com/libyal/libftxr/wiki/)                    | for Transactional Registry (TxR) data types (C)                                |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libftxr?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libftxr?label=) |                  ![License](https://img.shields.io/github/license/libyal/libftxr?label=) |
| [libfusn](https://github.com/libyal/libfusn/wiki/)                    | for Update Sequence Number (USN) Journal data types (C)                        |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfusn?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libfusn?label=) |                  ![License](https://img.shields.io/github/license/libyal/libfusn?label=) |
| [libfvalue](https://github.com/libyal/libfvalue/wiki/)                | generic file value functions (C)                                               |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfvalue?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libfvalue?label=) |                ![License](https://img.shields.io/github/license/libyal/libfvalue?label=) |
| [libfwevt](https://github.com/libyal/libfwevt/wiki/)                  | for Windows XML Event Log (EVTX) data types (C)                                |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfwevt?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libfwevt?label=) |                 ![License](https://img.shields.io/github/license/libyal/libfwevt?label=) |
| [libfwnt](https://github.com/libyal/libfwnt/wiki/)                    | for Windows NT data types (C)                                                  |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfwnt?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libfwnt?label=) |                  ![License](https://img.shields.io/github/license/libyal/libfwnt?label=) |
| [libfwps](https://github.com/libyal/libfwps/wiki/)                    | for Windows Property Store data types (C)                                      |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfwps?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libfwps?label=) |                  ![License](https://img.shields.io/github/license/libyal/libfwps?label=) |
| [libfwsi](https://github.com/libyal/libfwsi/wiki/)                    | for Windows Shell Item data types (C)                                          |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfwsi?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libfwsi?label=) |                  ![License](https://img.shields.io/github/license/libyal/libfwsi?label=) |
| [libhmac](https://github.com/libyal/libhmac/wiki/)                    | Hash-based Message Authentication Codes (HMAC) (C)                             |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libhmac?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libhmac?label=) |                  ![License](https://img.shields.io/github/license/libyal/libhmac?label=) |
| [libuna](https://github.com/libyal/libuna/wiki/)                      | Unicode and ASCII (byte string) conversions (C)                                |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libuna?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libuna?label=) |                   ![License](https://img.shields.io/github/license/libyal/libuna?label=) |
| **File Formats**                                                      |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [libagdb](https://github.com/libyal/libagdb/wiki/)                    | Windows SuperFetch database format (C)                                         |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libagdb?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libagdb?label=) |                  ![License](https://img.shields.io/github/license/libyal/libagdb?label=) |
| [libcreg](https://github.com/libyal/libcreg/wiki/)                    | Windows 9x/Me Registry File (CREG) format (C)                                  |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libcreg?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libcreg?label=) |                  ![License](https://img.shields.io/github/license/libyal/libcreg?label=) |
| [libesedb](https://github.com/libyal/libesedb/wiki/)                  | Extensible Storage Engine (ESE) Database File (EDB) format (C)                 |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libesedb?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libesedb?label=) |                 ![License](https://img.shields.io/github/license/libyal/libesedb?label=) |
| [libevt](https://github.com/libyal/libevt/wiki/)                      | Windows Event Log (EVT) format (C)                                             |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libevt?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libevt?label=) |                   ![License](https://img.shields.io/github/license/libyal/libevt?label=) |
| [libevtx](https://github.com/libyal/libevtx/wiki/)                    | Windows XML Event Log (EVTX) format (C)                                        |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libevtx?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libevtx?label=) |                  ![License](https://img.shields.io/github/license/libyal/libevtx?label=) |
| [libexe](https://github.com/libyal/libexe/wiki/)                      | PE/COFF Executable (EXE) format (C)                                            |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libexe?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libexe?label=) |                   ![License](https://img.shields.io/github/license/libyal/libexe?label=) |
| [libgzipf](https://github.com/libyal/libgzipf/wiki/)                  | GZIP file format (C)                                                           |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libgzipf?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libgzipf?label=) |                 ![License](https://img.shields.io/github/license/libyal/libgzipf?label=) |
| [liblnk](https://github.com/libyal/liblnk/wiki/)                      | Windows Shortcut File (LNK) format (C)                                         |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/liblnk?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/liblnk?label=) |                   ![License](https://img.shields.io/github/license/libyal/liblnk?label=) |
| [libmdmp](https://github.com/libyal/libmdmp/wiki/)                    | Windows Minidump (MDMP) format (C)                                             |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libmdmp?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libmdmp?label=) |                  ![License](https://img.shields.io/github/license/libyal/libmdmp?label=) |
| [libmsiecf](https://github.com/libyal/libmsiecf/wiki/)                | Microsoft Internet Explorer (MSIE) Cache File (index.dat) format (C)           |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libmsiecf?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libmsiecf?label=) |                ![License](https://img.shields.io/github/license/libyal/libmsiecf?label=) |
| [libnk2](https://github.com/libyal/libnk2/wiki/)                      | Microsoft Outlook Nickfile (NK2) format (C)                                    |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libnk2?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libnk2?label=) |                   ![License](https://img.shields.io/github/license/libyal/libnk2?label=) |
| [libnsfdb](https://github.com/libyal/libnsfdb/wiki/)                  | Notes Storage Facility (NSF) database file format (C)                          |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libnsfdb?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libnsfdb?label=) |                 ![License](https://img.shields.io/github/license/libyal/libnsfdb?label=) |
| [libolecf](https://github.com/libyal/libolecf/wiki/)                  | OLE 2 Compound File (OLECF) format (C)                                         |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libolecf?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libolecf?label=) |                 ![License](https://img.shields.io/github/license/libyal/libolecf?label=) |
| [libpff](https://github.com/libyal/libpff/wiki/)                      | Personal Folder File (PFF) format (C)                                          |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libpff?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libpff?label=) |                   ![License](https://img.shields.io/github/license/libyal/libpff?label=) |
| [libregf](https://github.com/libyal/libregf/wiki/)                    | Windows NT Registry File (REGF) format (C)                                     |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libregf?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libregf?label=) |                  ![License](https://img.shields.io/github/license/libyal/libregf?label=) |
| [libscca](https://github.com/libyal/libscca/wiki/)                    | Windows Prefetch File (SCCA) format (C)                                        |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libscca?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libscca?label=) |                  ![License](https://img.shields.io/github/license/libyal/libscca?label=) |
| [libwtcdb](https://github.com/libyal/libwtcdb/wiki/)                  | Windows (Vista/7) Explorer thumbnail cache database format (thumbcache.db) (C) |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libwtcdb?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libwtcdb?label=) |                 ![License](https://img.shields.io/github/license/libyal/libwtcdb?label=) |
| [dfwinreg](https://github.com/log2timeline/dfwinreg)                  | Digital Forensics Windows Registry (dfWinReg) (Python)                         |           ![Last Commit](https://img.shields.io/github/last-commit/log2timeline/dfwinreg?label=) |           ![GitHub stars](https://img.shields.io/github/stars/log2timeline/dfwinreg?label=) |           ![License](https://img.shields.io/github/license/log2timeline/dfwinreg?label=) |
| [evtx](https://github.com/Velocidex/evtx)                             | Parser for Microsoft Event Logs (Go)                                           |                  ![Last Commit](https://img.shields.io/github/last-commit/Velocidex/evtx?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/Velocidex/evtx?label=) |                  ![License](https://img.shields.io/github/license/Velocidex/evtx?label=) |
| [go-prefetch](https://github.com/Velocidex/go-prefetch)               | A implementation of a prefetch parser. (Go)                                    |           ![Last Commit](https://img.shields.io/github/last-commit/Velocidex/go-prefetch?label=) |           ![GitHub stars](https://img.shields.io/github/stars/Velocidex/go-prefetch?label=) |           ![License](https://img.shields.io/github/license/Velocidex/go-prefetch?label=) |
| [python-evt](https://github.com/williballenthin/python-evt)           | Parser for classic Windows Event Log files (.evt) (Python)                     |      ![Last Commit](https://img.shields.io/github/last-commit/williballenthin/python-evt?label=) |      ![GitHub stars](https://img.shields.io/github/stars/williballenthin/python-evt?label=) |      ![License](https://img.shields.io/github/license/williballenthin/python-evt?label=) |
| [python-evtx](https://github.com/williballenthin/python-evtx)         | Parser for recent Windows Event Log files (.evtx) (Python)                     |     ![Last Commit](https://img.shields.io/github/last-commit/williballenthin/python-evtx?label=) |     ![GitHub stars](https://img.shields.io/github/stars/williballenthin/python-evtx?label=) |     ![License](https://img.shields.io/github/license/williballenthin/python-evtx?label=) |
| [python-registry](https://github.com/williballenthin/python-registry) | Parser for Windows Registry hives. (Python)                                    | ![Last Commit](https://img.shields.io/github/last-commit/williballenthin/python-registry?label=) | ![GitHub stars](https://img.shields.io/github/stars/williballenthin/python-registry?label=) | ![License](https://img.shields.io/github/license/williballenthin/python-registry?label=) |
| [python-sdb](https://github.com/williballenthin/python-sdb)           | Parser for Application Compatibility Shim Databases (.sdb files) (Python)      |      ![Last Commit](https://img.shields.io/github/last-commit/williballenthin/python-sdb?label=) |      ![GitHub stars](https://img.shields.io/github/stars/williballenthin/python-sdb?label=) |      ![License](https://img.shields.io/github/license/williballenthin/python-sdb?label=) |
| **In-file Formats**                                                   |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [libmapidb](https://github.com/libyal/libmapidb/wiki/)                | Exchange MAPI database format (C)                                              |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libmapidb?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libmapidb?label=) |                ![License](https://img.shields.io/github/license/libyal/libmapidb?label=) |
| [libwrc](https://github.com/libyal/libwrc/wiki/)                      | Windows Resource Compiler (WRC) format (C)                                     |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libwrc?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libwrc?label=) |                   ![License](https://img.shields.io/github/license/libyal/libwrc?label=) |
| **File System Formats**                                               |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [libfsapfs](https://github.com/libyal/libfsapfs/wiki/)                | Apple File System (APFS) format (C)                                            |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfsapfs?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libfsapfs?label=) |                ![License](https://img.shields.io/github/license/libyal/libfsapfs?label=) |
| [libfsclfs](https://github.com/libyal/libfsclfs/wiki/)                | Common Log File System (CLFS) format (C)                                       |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfsclfs?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libfsclfs?label=) |                ![License](https://img.shields.io/github/license/libyal/libfsclfs?label=) |
| [libfsext](https://github.com/libyal/libfsext/wiki/)                  | Extended File System (EXT) format (C)                                          |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfsext?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libfsext?label=) |                 ![License](https://img.shields.io/github/license/libyal/libfsext?label=) |
| [libfshfs](https://github.com/libyal/libfshfs/wiki/)                  | Hierarchical File System (HFS) format (C)                                      |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfshfs?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libfshfs?label=) |                 ![License](https://img.shields.io/github/license/libyal/libfshfs?label=) |
| [libfsntfs](https://github.com/libyal/libfsntfs/wiki/)                | New Technology File System (NTFS) format (C)                                   |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfsntfs?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libfsntfs?label=) |                ![License](https://img.shields.io/github/license/libyal/libfsntfs?label=) |
| [libfsrefs](https://github.com/libyal/libfsrefs/wiki/)                | Resilient File System (ReFS) format (C)                                        |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfsrefs?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libfsrefs?label=) |                ![License](https://img.shields.io/github/license/libyal/libfsrefs?label=) |
| [go-ntfs](https://github.com/Velocidex/go-ntfs)                       | An NTFS file parser (Go)                                                       |               ![Last Commit](https://img.shields.io/github/last-commit/Velocidex/go-ntfs?label=) |               ![GitHub stars](https://img.shields.io/github/stars/Velocidex/go-ntfs?label=) |               ![License](https://img.shields.io/github/license/Velocidex/go-ntfs?label=) |
| [python-ntfs](https://github.com/williballenthin/python-ntfs)         | Library for NTFS analysis (Python)                                             |     ![Last Commit](https://img.shields.io/github/last-commit/williballenthin/python-ntfs?label=) |     ![GitHub stars](https://img.shields.io/github/stars/williballenthin/python-ntfs?label=) |     ![License](https://img.shields.io/github/license/williballenthin/python-ntfs?label=) |
| **Volume (System) Formats**                                           |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [libbde](https://github.com/libyal/libbde/wiki/)                      | BitLocker drive encryption (BDE) (C)                                           |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libbde?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libbde?label=) |                   ![License](https://img.shields.io/github/license/libyal/libbde?label=) |
| [libfvde](https://github.com/libyal/libfvde/wiki/)                    | FileVault drive encryption (FVDE) (C)                                          |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libfvde?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libfvde?label=) |                  ![License](https://img.shields.io/github/license/libyal/libfvde?label=) |
| [libluksde](https://github.com/libyal/libluksde/wiki/)                | LUKS Disk Encryption (C)                                                       |                ![Last Commit](https://img.shields.io/github/last-commit/libyal/libluksde?label=) |                ![GitHub stars](https://img.shields.io/github/stars/libyal/libluksde?label=) |                ![License](https://img.shields.io/github/license/libyal/libluksde?label=) |
| [libvsgpt](https://github.com/libyal/libvsgpt/wiki/)                  | GUID Partition Table (GPT) volume system format (C)                            |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libvsgpt?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libvsgpt?label=) |                 ![License](https://img.shields.io/github/license/libyal/libvsgpt?label=) |
| [libvshadow](https://github.com/libyal/libvshadow/wiki/)              | Volume Shadow Snapshot (VSS) format (C)                                        |               ![Last Commit](https://img.shields.io/github/last-commit/libyal/libvshadow?label=) |               ![GitHub stars](https://img.shields.io/github/stars/libyal/libvshadow?label=) |               ![License](https://img.shields.io/github/license/libyal/libvshadow?label=) |
| [libvslvm](https://github.com/libyal/libvslvm/wiki/)                  | Linux Logical Volume Manager (LVM) volume system format (C)                    |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libvslvm?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libvslvm?label=) |                 ![License](https://img.shields.io/github/license/libyal/libvslvm?label=) |
| [libvsmbr](https://github.com/libyal/libvsmbr/wiki/)                  | Master Boot Record (MBR) volume system format (C)                              |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libvsmbr?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libvsmbr?label=) |                 ![License](https://img.shields.io/github/license/libyal/libvsmbr?label=) |
| **Storage Media Image Formats**                                       |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [pyaff4](https://github.com/aff4/pyaff4)                              | A implementation of the AFF4 standard. (Python)                                |                     ![Last Commit](https://img.shields.io/github/last-commit/aff4/pyaff4?label=) |                     ![GitHub stars](https://img.shields.io/github/stars/aff4/pyaff4?label=) |                     ![License](https://img.shields.io/github/license/aff4/pyaff4?label=) |
| [libewf](https://github.com/libyal/libewf/wiki/)                      | Expert Witness Compression Format (EWF) image format (C)                       |                   ![Last Commit](https://img.shields.io/github/last-commit/libyal/libewf?label=) |                   ![GitHub stars](https://img.shields.io/github/stars/libyal/libewf?label=) |                   ![License](https://img.shields.io/github/license/libyal/libewf?label=) |
| [libhibr](https://github.com/libyal/libhibr/wiki/)                    | Windows Hibernation File (hiberfil.sys) format (C)                             |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libhibr?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libhibr?label=) |                  ![License](https://img.shields.io/github/license/libyal/libhibr?label=) |
| [libmodi](https://github.com/libyal/libmodi/wiki/)                    | Mac OS disk image formats (C)                                                  |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libmodi?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libmodi?label=) |                  ![License](https://img.shields.io/github/license/libyal/libmodi?label=) |
| [libodraw](https://github.com/libyal/libodraw/wiki/)                  | optical disc (split) RAW image format (bin/cue, iso/cue) (C)                   |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libodraw?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libodraw?label=) |                 ![License](https://img.shields.io/github/license/libyal/libodraw?label=) |
| [libphdi](https://github.com/libyal/libphdi/wiki/)                    | Parallels Hard Disk image format (C)                                           |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libphdi?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libphdi?label=) |                  ![License](https://img.shields.io/github/license/libyal/libphdi?label=) |
| [libqcow](https://github.com/libyal/libqcow/wiki/)                    | QEMU Copy-On-Write (QCOW) image format (C)                                     |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libqcow?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libqcow?label=) |                  ![License](https://img.shields.io/github/license/libyal/libqcow?label=) |
| [libsmdev](https://github.com/libyal/libsmdev/wiki/)                  | storage media devices (C)                                                      |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libsmdev?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libsmdev?label=) |                 ![License](https://img.shields.io/github/license/libyal/libsmdev?label=) |
| [libsmraw](https://github.com/libyal/libsmraw/wiki/)                  | (split) RAW image format (C)                                                   |                 ![Last Commit](https://img.shields.io/github/last-commit/libyal/libsmraw?label=) |                 ![GitHub stars](https://img.shields.io/github/stars/libyal/libsmraw?label=) |                 ![License](https://img.shields.io/github/license/libyal/libsmraw?label=) |
| [libvhdi](https://github.com/libyal/libvhdi/wiki/)                    | Virtual Hard Disk (VHD) image format (C)                                       |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libvhdi?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libvhdi?label=) |                  ![License](https://img.shields.io/github/license/libyal/libvhdi?label=) |
| [libvmdk](https://github.com/libyal/libvmdk/wiki/)                    | VMware Virtual Disk (VMDK) format (C)                                          |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libvmdk?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libvmdk?label=) |                  ![License](https://img.shields.io/github/license/libyal/libvmdk?label=) |
| [aff4](https://github.com/py4n6/aff4)                                 | Advanced Forensic File Format 4 (Python (&amp; C))                             |                      ![Last Commit](https://img.shields.io/github/last-commit/py4n6/aff4?label=) |                      ![GitHub stars](https://img.shields.io/github/stars/py4n6/aff4?label=) |                      ![License](https://img.shields.io/github/license/py4n6/aff4?label=) |
| [c-aff4](https://github.com/Velocidex/c-aff4)                         | An AFF4 C++ implementation. (C++)                                              |                ![Last Commit](https://img.shields.io/github/last-commit/Velocidex/c-aff4?label=) |                ![GitHub stars](https://img.shields.io/github/stars/Velocidex/c-aff4?label=) |                ![License](https://img.shields.io/github/license/Velocidex/c-aff4?label=) |
| **Utility Libraries**                                                 |                                                                                |                                                                                                  |                                                                                             |                                                                                          |
| [libbfio](https://github.com/libyal/libbfio/wiki/)                    | basic file input/output abstraction (C)                                        |                  ![Last Commit](https://img.shields.io/github/last-commit/libyal/libbfio?label=) |                  ![GitHub stars](https://img.shields.io/github/stars/libyal/libbfio?label=) |                  ![License](https://img.shields.io/github/license/libyal/libbfio?label=) |
| [libsigscan](https://github.com/libyal/libsigscan/wiki/)              | binary signature scanning (C)                                                  |               ![Last Commit](https://img.shields.io/github/last-commit/libyal/libsigscan?label=) |               ![GitHub stars](https://img.shields.io/github/stars/libyal/libsigscan?label=) |               ![License](https://img.shields.io/github/license/libyal/libsigscan?label=) |
| [libtableau](https://github.com/libyal/libtableau/wiki/)              | read metadata from Tableau(TM) forensic bridges (write blockers) (C)           |               ![Last Commit](https://img.shields.io/github/last-commit/libyal/libtableau?label=) |               ![GitHub stars](https://img.shields.io/github/stars/libyal/libtableau?label=) |               ![License](https://img.shields.io/github/license/libyal/libtableau?label=) |
